#include <code/query/tag.hxx>

namespace code::query
{

  tag_t::
  tag_t(string identifier, term_t value)
    : identifier_{move(identifier)},
      value_{move(value)}
  {}

  tag_t::
  tag_t(source_location_t origin,
      string identifier,
      term_t value)
    : origin_{move(origin)},
      identifier_{move(identifier)},
      value_{move(value)}
  {}

  source_location_t const&
  tag_t::
  origin() const
  {
    return origin_;
  }

  string const&
  tag_t::
  identifier() const
  {
    return identifier_;
  }

  term_t const&
  tag_t::
  value() const
  {
    return value_;
  }

  string
  to_string(tag_t const& e)
  {
    return e.identifier() + ":" + to_string(e.value());
  }

} // namespace code::query
